PROGRAM MIDAS2LCIO
   USE DataFormats
   USE TPCio
   USE TPCdata
   USE LCIO4TPC

   INTEGER :: IERR,i=0,iflag=0
   INTEGER :: Event_first,Event_last,nEvents
   INTEGER,DIMENSION(50) :: eventList
   CHARACTER(LEN=80) :: chDate,chComment,CHVersion="0.0"
   
! initialize the files, allocate arrays
   CALL IOinitialize(ChVersion,Event_first,Event_last,nEvents,eventList)          
! open the MIDAS file
   CALL OPENData(IERR)
! open the LCIO output file
   CALL OpenWriteLCIO()
   
! read the header of MIDAS data
   CALL ReadHeader(chComment,chDate)
! write the header to LCIO
   CALL WriteLCIOHeader(chComment,chDate)

   IF( nTbin == 0 )THEN
! will write amplitude / time
      iflag = IBSET(iflag,1)
   ELSE
! will write RawData
      iflag = IBSET(iflag,0)
   ENDIF
   
   EventLoop: DO 
      CALL ReadEvent(IERR)
      IF( EventNumber > 100 )  IERR = 1
      IF( IERR /= 0 ) EXIT EventLoop
      
      i=i+1
      IF( modulo(i,50)==0 ) &
      PRINT*,"Run, Event ",i,RunNumber,EventNumber
      
      CALL WriteLCIOEvent(iflag)
   ENDDO EventLoop

! close/open the MIDAS/DD file
   CALL OPENData(IERR)
   CALL CloseWriteLCIO()
END PROGRAM MIDAS2LCIO
   
